import { getResistance } from "./lib/resistance_table";
import { Vector } from "./lib/Util";

export default function (b) {
    let typeId = b.typeId;
    let skin = -1, rot = new Vector(), id = typeId.split(":")[1];
    let group = "", data = 0, op = [], resistance = 1, solid = 2;
    
    if (id.endsWith("_helm")) {
        resistance = getResistance("helm");
        solid = 0;
    }
    else if ((op = ["oak_planks", "spruce_planks", "birch_planks", "jungle_planks", "acacia_planks", "dark_oak_planks", "mangrove_planks", "cherry_planks", "bamboo_planks", "bamboo_mosaic", "crimson_planks", "warped_planks", "pale_oak_planks", "resin_bricks", "chiseled_resin_bricks"]).includes(id)) {
        skin = op.indexOf(id);
        resistance = getResistance("planks");
    }
    else if ((op = ["oak_double_slab", "spruce_double_slab", "birch_double_slab", "jungle_double_slab", "acacia_double_slab", "dark_oak_double_slab", "mangrove_double_slab", "cherry_double_slab", "bamboo_double_slab", "bamboo_mosaic_double_slab", "crimson_double_slab", "warped_double_slab", "pale_oak_double_slab"]).includes(id)) {
        skin = op.indexOf(id);
        resistance = getResistance("double_slab");
    }
    else if ((op = ["oak_slab", "spruce_slab", "birch_slab", "jungle_slab", "acacia_slab", "dark_oak_slab", "mangrove_slab", "cherry_slab", "bamboo_slab", "bamboo_mosaic_slab", "crimson_slab", "warped_slab", "pale_oak_slab"]).includes(id)) {
        skin = op.indexOf(id);
        data = 3;
        solid = 1;
        rot.x = b.getState("minecraft:vertical_half") == "top" ? 2 : 0;
        resistance = getResistance("wooden_slab");
    }
    else if ((op = ["oak_fence", "spruce_fence", "birch_fence", "jungle_fence", "acacia_fence", "dark_oak_fence", "mangrove_fence", "cherry_fence", "bamboo_fence", "crimson_fence", "warped_fence", "pale_oak_fence"]).includes(id)) {
        skin = op.indexOf(id);
        solid = 0;
        if (id === "crimson_fence" || id === "warped_fence" || id === "pale_oak_fence") skin += 1;
        let r = "", n = b.north(), s = b.south(), e = b.east(), w = b.west();
        if (n && !n.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "n";
        if (w && !w.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "w";
        if (s && !s.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "s";
        if (e && !e.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "e";
        if (r.length === 1) {
            data = 1;
            rot.y = "nesw".indexOf(r);
        }
        else if (r.length === 2) {
            let list = [];
            if ((list = ["ns", "we"]).includes(r)) data = 2;
            else if ((list = ["ne", "se", "ws", "nw"]).includes(r)) data = 3;
            rot.y = list.indexOf(r);
        }
        else if (r.length === 3) {
            data = 4;
            rot.y = ["nse", "wse", "nws", "nwe"].indexOf(r);
        }
        else if (r.length === 4) data = 5;

        group = "3";
        resistance = getResistance("fence");
    }
    else if ((op = ["fence_gate", "spruce_fence_gate", "birch_fence_gate", "jungle_fence_gate", "acacia_fence_gate", "dark_oak_fence_gate", "mangrove_fence_gate", "cherry_fence_gate", "bamboo_fence_gate", "crimson_fence_gate", "warped_fence_gate", "pale_oak_fence_gate"]).includes(id)) {
        skin = op.indexOf(id);
        solid = 0;
        if (id === "crimson_fence_gate" || id === "warped_fence_gate" || id === "pale_oak_fence_gate") skin += 1;
        rot.y = b.getState("direction") || 0;
        data = 6 + (b.getState("open_bit") ? 1 : 0);
        group = "3";
        resistance = getResistance("gate");
    }


    else if ((op = ["white_wool", "light_gray_wool", "gray_wool", "black_wool", "brown_wool", "red_wool", "orange_wool", "yellow_wool", "lime_wool", "green_wool", "cyan_wool", "light_blue_wool", "blue_wool", "purple_wool", "magenta_wool", "pink_wool"]).includes(id)) {
        skin = 1 * 20 + op.indexOf(id);
        resistance = getResistance("wool");
    }
    else if ((op = ["white_carpet", "light_gray_carpet", "gray_carpet", "black_carpet", "brown_carpet", "red_carpet", "orange_carpet", "yellow_carpet", "lime_carpet", "green_carpet", "cyan_carpet", "light_blue_carpet", "blue_carpet", "purple_carpet", "magenta_carpet", "pink_carpet", "moss_carpet", "pale_moss_carpet"]).includes(id)) {
        skin = 1 * 20 + op.indexOf(id);
        if (id === "moss_carpet") skin = 164;
        else if (id === "pale_moss_carpet") skin = 172;
        data = 1;
        solid = 1;
        resistance = getResistance("carpet");
    }

    else if ((op = ["glass", "white_stained_glass", "light_gray_stained_glass", "gray_stained_glass", "black_stained_glass", "brown_stained_glass", "red_stained_glass", "orange_stained_glass", "yellow_stained_glass", "lime_stained_glass", "green_stained_glass", "cyan_stained_glass", "light_blue_stained_glass", "blue_stained_glass", "purple_stained_glass", "magenta_stained_glass", "pink_stained_glass", "tinted_glass"]).includes(id)) {
        skin = 2 * 20 + op.indexOf(id);
        resistance = getResistance("glass");
        solid = 0;
    }
    else if ((op = ["stone", "cobblestone", "mossy_cobblestone", "granite", "diorite", "andesite", "stone_bricks", "mossy_stone_bricks", "cracked_stone_bricks", "chiseled_stone_bricks", "smooth_stone", "polished_granite", "polished_diorite", "polished_andesite", "quartz_block", "quartz_bricks", "quartz_pillar", "chiseled_quartz_block", "smooth_quartz"]).includes(id)) {
        skin = 3 * 20 + op.indexOf(id);
        if (b.getState("pillar_axis")) rot = getBlockRotation(b, "pillar_axis");
        resistance = getResistance("stone");
    }
    else if ((op = ["normal_stone_double_slab", "cobblestone_double_slab", "mossy_cobblestone_double_slab", "granite_double_slab", "diorite_double_slab", "andesite_double_slab", "stone_brick_double_slab", "mossy_stone_brick_double_slab", "polished_granite_double_slab", "polished_diorite_double_slab", "polished_andesite_double_slab", "quartz_double_slab", "smooth_quartz_double_slab"]).includes(id)) {
        skin = 3 * 20 + op.indexOf(id);
        if ((op = ["polished_granite_double_slab", "polished_diorite_double_slab", "polished_andesite_double_slab", "quartz_double_slab", "smooth_quartz_double_slab"]).includes(id)) {
            skin = 3 * 20 + 11 + op.indexOf(id);
            if (id === "smooth_quartz_double_slab") skin = 3 * 20 + 18;
        }
        resistance = getResistance("stone");
    }
    else if ((op = ["normal_stone_slab", "cobblestone_slab", "mossy_cobblestone_slab", "granite_slab", "diorite_slab", "andesite_slab", "stone_brick_slab", "mossy_stone_brick_slab", "smooth_stone_slab", "polished_granite_slab", "polished_diorite_slab", "polished_andesite_slab", "quartz_slab", "smooth_quartz_slab"]).includes(id)) {
        skin = 3 * 20 + op.indexOf(id);
        if ((op = ["smooth_stone_slab", "polished_granite_slab", "polished_diorite_slab", "polished_andesite_slab", "quartz_slab", "smooth_quartz_slab"]).includes(id)) {
            skin = 3 * 20 + 10 + op.indexOf(id);
            if (id === "smooth_quartz_slab") skin = 3 * 20 + 18;
        }
        data = 3;
        solid = 1;
        rot.x = b.getState("minecraft:vertical_half") == "top" ? 2 : 0;
        resistance = getResistance("stone");
    }
    else if ((op = ["oak_log", "spruce_log", "birch_log", "jungle_log", "acacia_log", "dark_oak_log", "mangrove_log", "cherry_log", "crimson_stem", "warped_stem", "pale_oak_log"]).includes(id)) {
        skin = 4 * 20 + op.indexOf(id);
        rot = getBlockRotation(b, "pillar_axis");
        resistance = getResistance("log");
    }
    else if ((op = ["stripped_oak_log", "stripped_spruce_log", "stripped_birch_log", "stripped_jungle_log", "stripped_acacia_log", "stripped_dark_oak_log", "stripped_mangrove_log", "stripped_cherry_log", "stripped_crimson_stem", "stripped_warped_stem", "stripped_pale_oak_log"]).includes(id)) {
        skin = 5 * 20 + op.indexOf(id);
        rot = getBlockRotation(b, "pillar_axis");
        resistance = getResistance("log");
    }
    else if ((op = ["oak_wood", "spruce_wood", "birch_wood", "jungle_wood", "acacia_wood", "dark_oak_wood", "mangrove_wood", "cherry_wood", "crimson_hyphae", "warped_hyphae", "bamboo_block", "pale_oak_wood"]).includes(id)) {
        skin = 6 * 20 + op.indexOf(id);
        rot = getBlockRotation(b, "pillar_axis");
        resistance = getResistance("log");
    }
    else if ((op = ["stripped_oak_wood", "stripped_spruce_wood", "stripped_birch_wood", "stripped_jungle_wood", "stripped_acacia_wood", "stripped_dark_oak_wood", "stripped_mangrove_wood", "stripped_cherry_wood", "stripped_crimson_hyphae", "stripped_warped_hyphae", "stripped_bamboo_block", "stripped_pale_oak_wood"]).includes(id)) {
        skin = 7 * 20 + op.indexOf(id);
        rot = getBlockRotation(b, "pillar_axis");
        resistance = getResistance("log");
    }
    else if ((op = ["nether_wart_block", "warped_wart_block", "shroomlight", "glowstone", "moss_block", "carved_pumpkin", "lit_pumpkin", "hay_block", "sea_lantern", "pearlescent_froglight", "verdant_froglight", "ochre_froglight", "pale_moss_block", "resin_block"]).includes(id)) {
        skin = 8 * 20 + op.indexOf(id);
        rot = getBlockRotation(b, "pillar_axis");
        if (b.getState("minecraft:cardinal_direction")) rot = getBlockRotation(b, "minecraft:cardinal_direction");
        resistance = getResistance(id);
    }
    else if ((op = ["crafting_table", "cartography_table", "fletching_table", "smithing_table", "furnace", "lit_furnace", "blast_furnace", "lit_blast_furnace", "smoker", "lit_smoker", "bookshelf", "barrel", "noteblock", "jukebox", "redstone_lamp", "lit_redstone_lamp", "loom", "composter", "ladder", "chain"]).includes(id)) {
        skin = 9 * 20 + op.indexOf(id);
        rot = getBlockRotation(b, "pillar_axis");
        if (b.getState("minecraft:cardinal_direction")) rot = getBlockRotation(b, "minecraft:cardinal_direction");
        if (id == "barrel") rot = getBlockRotation(b, "facing_direction");
        else if (id == "loom") rot.y = b.getState("direction") || 0;
        resistance = getResistance(id);
        if (id.includes("stripped")) resistance = getResistance("wood");
        else if (id.includes("stone")) resistance = getResistance("stone");
        else if (id.includes("furnace")) resistance = getResistance("furnace");
        else if (id.includes("lamp")) resistance = getResistance("redstone_lamp");
        else if (id.includes("lantern")) resistance = getResistance("lantern");
        else if (id.includes("ladder")) {
            data = 2;
            solid = 0;
            rot = getBlockRotation(b, "facing_direction");
        }
        else if (id.includes("chain")) solid = 0;
    }
    else if ((op = ["torch", "soul_torch", "end_rod", "lantern", "soul_lantern", "anvil", "chipped_anvil", "damaged_anvil", "stonecutter_block", "grindstone", "enchanting_table", "brewing_stand", "lectern", "_lectern", "cauldron", "_cauldron"]).includes(id)) {
        skin = 10 * 20 + op.indexOf(id);
        solid = 0;
        resistance = getResistance(id);
        if (id.includes("torch")) {
            data = b.getState("torch_facing_direction") == "top" ? 0 : 1;
            rot = getBlockRotation(b, "torch_facing_direction");
        }
        else if (id.includes("end_rod")) {
            if (b.getState('facing_direction') == 1) rot.x = 0;
            else if (b.getState('facing_direction') == 2) rot.x = 1;
            else if (b.getState('facing_direction') == 3) rot.x = 3;
            else if (b.getState('facing_direction') == 4) rot.z = 1;
            else if (b.getState('facing_direction') == 5) rot.z = 3;
            else rot.x = 2;
        }
        else if (id.includes("lantern")) data = b.getState("hanging") ? 1 : 0;
        else if (id.includes("anvil")) {
            rot = getBlockRotation(b, "minecraft:cardinal_direction");
            resistance = getResistance("anvil");
        }
        else if (id === "stonecutter_block") {
            solid = 1;
            rot = getBlockRotation(b, "minecraft:cardinal_direction");
        }
        else if (id === "grindstone") {
            solid = 0;
            if (b.getState("attachment") == "side") rot.x = 1;
            if (b.getState("attachment") == "hanging") rot.x = 2;
            rot.y = b.getState("direction");
        }
        else if (id === "enchanting_table") solid = 1;
        else if (id === "brewing_stand") {
            let r = b.getState("brewing_stand_slot_a_bit") ? "a" : "";
            r += b.getState("brewing_stand_slot_b_bit") ? "b" : "";
            r += b.getState("brewing_stand_slot_c_bit") ? "c" : "";
            if (r.length == 1) {
                if (r === "a") data = 1;
                else if (r === "b") data = 2;
                else if (r === "c") data = 3;
            }
            else if (r.length == 2) {
                if (r === "ab") data = 4;
                else if (r === "ac") data = 5;
                else if (r === "bc") data = 6;
            }
            else if (r.length == 3) data = 7;
            group = "1";
        }
        else if (id == "lectern") {
            rot = getBlockRotation(b, "minecraft:cardinal_direction");
            group = "1";
        }
        else if (id == "cauldron") group = "1";
    }
    else if ((op = ["chest", "trapped_chest", "ender_chest", "undyed_shulker_box", "white_shulker_box", "light_gray_shulker_box", "gray_shulker_box", "black_shulker_box", "brown_shulker_box", "red_shulker_box", "orange_shulker_box", "yellow_shulker_box", "lime_shulker_box", "green_shulker_box", "cyan_shulker_box", "light_blue_shulker_box", "blue_shulker_box", "purple_shulker_box", "magenta_shulker_box", "pink_shulker_box"]).includes(id)) {
        skin = 11 * 20 + op.indexOf(id);
        resistance = getResistance("chest");
        if (id.includes("chest")) {
            solid = 0;
            rot = getBlockRotation(b, "minecraft:cardinal_direction");
        }
        else if (id.includes("shulker_box")) resistance = getResistance("shulker_box");
    }
    else if (id === "furnace_engine") {
        skin = 12 * 20 + b.getState('mship:fuel');
        rot = getBlockRotation(b, 'minecraft:cardinal_direction');
        resistance = getResistance("furnace");
    }
    else if ((op = ["white_buoy", "light_gray_buoy", "gray_buoy", "black_buoy", "brown_buoy", "red_buoy", "orange_buoy", "yellow_buoy", "lime_buoy", "green_buoy", "cyan_buoy", "light_blue_buoy", "blue_buoy", "purple_buoy", "magenta_buoy", "pink_buoy"]).includes(id)) {
        skin = 13 * 20 + op.indexOf(id);
        solid = 0;
        rot = getBlockRotation(b, "minecraft:block_face");
        resistance = getResistance("buoy");
    }
    else if (id === "bed") {
        skin = 14 * 20;
        solid = 1;
        group = "1";
        rot.y = b.getState("direction") || 0;
        resistance = getResistance(id);
    }
    else if ((op = ["candle", "white_candle", "light_gray_candle", "gray_candle", "black_candle", "brown_candle", "red_candle", "orange_candle", "yellow_candle", "lime_candle", "green_candle", "cyan_candle", "light_blue_candle", "blue_candle", "purple_candle", "magenta_candle", "pink_candle"]).includes(id)) {
        skin = 15 * 20 + op.indexOf(id);
        solid = 0;
        group = "1"
        data = (b.getState("candles") || 0);
        resistance = getResistance("candle");
    }
    else if ((op = ["wooden_door", "spruce_door", "birch_door", "jungle_door", "acacia_door", "dark_oak_door", "mangrove_door", "cherry_door", "bamboo_door", "crimson_door", "warped_door", "pale_oak_door"]).includes(id)) {
        skin = 16 * 20 + op.indexOf(id);
        solid = 0;
        group = "1";
        rot.y = b.getState("direction") || 0;
        data = b.getState("open_bit") ? 1 : 0;
        resistance = getResistance("wooden_door");
    }
    else if ((op = ["trapdoor", "spruce_trapdoor", "birch_trapdoor", "jungle_trapdoor", "acacia_trapdoor", "dark_oak_trapdoor", "mangrove_trapdoor", "cherry_trapdoor", "bamboo_trapdoor", "crimson_trapdoor", "warped_trapdoor", "pale_oak_trapdoor"]).includes(id)) {
        skin = 17 * 20 + op.indexOf(id);
        solid = 1;
        group = "1";
        rot = getBlockRotation(b, "direction") || 0;
        if (b.getState("upside_down_bit")) rot.x = 2;
        data = b.getState("open_bit") ? 1 : 0;
        resistance = getResistance("wooden_trapdoor");
    }
    else if ((op = ["white_concrete", "light_gray_concrete", "gray_concrete", "black_concrete", "brown_concrete", "red_concrete", "orange_concrete", "yellow_concrete", "lime_concrete", "green_concrete", "cyan_concrete", "light_blue_concrete", "blue_concrete", "purple_concrete", "magenta_concrete", "pink_concrete"]).includes(id)) {
        skin = 18 * 20 + op.indexOf(id);
        resistance = getResistance("stone");
    }
    else if ((op = ["white_cushion", "silver_cushion", "gray_cushion", "black_cushion", "brown_cushion", "red_cushion", "orange_cushion", "yellow_cushion", "lime_cushion", "green_cushion", "cyan_cushion", "light_blue_cushion", "blue_cushion", "purple_cushion", "magenta_cushion", "pink_cushion"]).includes(id)) {
        skin = 1 * 20 + op.indexOf(id);
        solid = 0;
        group = "2";
        resistance = getResistance("cushion");
    }
    else if ((op = ["stool_a_planks_oak", "stool_a_planks_spruce", "stool_a_planks_birch", "stool_a_planks_jungle", "stool_a_planks_acacia", "stool_a_planks_dark_oak", "stool_a_planks_mangrove", "stool_a_planks_cherry", "stool_a_planks_bamboo", "stool_a_planks_crimson", "stool_a_planks_warped"]).includes(id)) {
        skin = op.indexOf(id);
        solid = 0;
        data = 1;
        group = "2";
        resistance = getResistance("stool");
    }
    else if ((op = ["stool_b_planks_oak", "stool_b_planks_spruce", "stool_b_planks_birch", "stool_b_planks_jungle", "stool_b_planks_acacia", "stool_b_planks_dark_oak", "stool_b_planks_mangrove", "stool_b_planks_cherry", "stool_b_planks_bamboo", "stool_b_planks_crimson", "stool_b_planks_warped"]).includes(id)) {
        skin = op.indexOf(id);
        solid = 0;
        data = 2;
        group = "2";
        resistance = getResistance("stool");
    }

    else if ((op = ["glass_pane", "white_stained_glass_pane", "light_gray_stained_glass_pane", "gray_stained_glass_pane", "black_stained_glass_pane", "brown_stained_glass_pane", "red_stained_glass_pane", "orange_stained_glass_pane", "yellow_stained_glass_pane", "lime_stained_glass_pane", "green_stained_glass_pane", "cyan_stained_glass_pane", "light_blue_stained_glass_pane", "blue_stained_glass_pane", "purple_stained_glass_pane", "magenta_stained_glass_pane", "pink_stained_glass_pane"]).includes(id)) {
        skin = 2 * 20 + op.indexOf(id);
        solid = 0;
        let r = "", n = b.north(), s = b.south(), e = b.east(), w = b.west();
        if (n && !n.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "n";
        if (w && !w.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "w";
        if (s && !s.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "s";
        if (e && !e.typeId.isOnList(["air", "water", "slab", "carpet"])) r += "e";
        if (r.length === 1) {
            data = 1;
            rot.y = "nesw".indexOf(r);
        }
        else if (r.length === 2) {
            let list = [];
            if ((list = ["ns", "we"]).includes(r)) data = 2;
            else if ((list = ["ne", "se", "ws", "nw"]).includes(r)) data = 3;
            rot.y = list.indexOf(r);
        }
        else if (r.length === 3) {
            data = 4;
            rot.y = ["nse", "wse", "nws", "nwe"].indexOf(r);
        }
        else if (r.length === 4) data = 5;

        group = "4";
        resistance = getResistance("glass");
    }

    // blocky5
    else if ((op = ["cobblestone_wall", "mossy_cobblestone_wall", "granite_wall", "diorite_wall", "andesite_wall", "stone_brick_wall", "mossy_stone_brick_wall"]).includes(id)) {
        skin = 3 * 20 + 1 + op.indexOf(id);
        solid = 0;

        let r = "";
        if (b.getState("wall_connection_type_north") != "none") r += "n";
        if (b.getState("wall_connection_type_west") != "none") r += "w";
        if (b.getState("wall_connection_type_south") != "none") r += "s";
        if (b.getState("wall_connection_type_east") != "none") r += "e";
        if (r.length === 1) {
            data = 1;
            rot.y = "nesw".indexOf(r);
        }
        else if (r.length === 2) {
            let list = [];
            if ((list = ["ns", "we"]).includes(r)) data = 2;
            else if ((list = ["ne", "se", "ws", "nw"]).includes(r)) data = 3;
            rot.y = list.indexOf(r);
        }
        else if (r.length === 3) {
            data = 4;
            rot.y = ["nse", "wse", "nws", "nwe"].indexOf(r);
        }
        else if (r.length === 4) data = 5;

        group = "5";
        resistance = getResistance("stone");
    }

    // blocky6
    else if (id.endsWith("_stairs")) {
        if ((op = ["oak_stairs", "spruce_stairs", "birch_stairs", "jungle_stairs", "acacia_stairs", "dark_oak_stairs", "mangrove_stairs", "cherry_stairs", "bamboo_stairs", "bamboo_mosaic_stairs", "crimson_stairs", "warped_stairs", "pale_oak_stairs"]).includes(id)) {
            skin = op.indexOf(id);
        }
        else if ((op = ["normal_stone_stairs", "stone_stairs", "mossy_cobblestone_stairs", "granite_stairs", "diorite_stairs", "andesite_stairs", "stone_brick_stairs", "mossy_stone_brick_stairs", "polished_granite_stairs", "polished_diorite_stairs", "polished_andesite_stairs", "quartz_stairs", "smooth_quartz_stairs"]).includes(id)) {
            skin = 3 * 20 + op.indexOf(id);
            if (id.includes("polished")) skin += 3;
            else if (id === "quartz_stairs") skin = 3 * 20 + 14;
            else if (id === "smooth_quartz_stairs") skin = 3 * 20 + 18;
        }
        data = 0;
        solid = 1;
        rot = getBlockRotation(b, "weirdo_direction");
        const up = b.getState("upside_down_bit"), n = b.north(), s = b.south(), e = b.east(), w = b.west();
        const nwd = n.getState("weirdo_direction"), swd = s.getState("weirdo_direction"), ewd = e.getState("weirdo_direction"), wwd = w.getState("weirdo_direction");
        const nu = n.getState("upside_down_bit"), su = s.getState("upside_down_bit"), eu = e.getState("upside_down_bit"), wu = w.getState("upside_down_bit");
        const nv = n.typeId.endsWith("stairs"), sv = s.typeId.endsWith("stairs"), ev = e.typeId.endsWith("stairs"), wv = w.typeId.endsWith("stairs");
        if (!b.getState("weirdo_direction")) {
            if (up == eu && ewd == 2 && up == su && !swd) data = up ? 1 : 2;
            else if (up == eu && ewd == 3 && up == nu && nv && !nwd) data = up ? 2 : 1;
            else if (up == wu && wwd == 3 && up == su && sv && !swd) data = up ? 4 : 3;
            else if (up == wu && wwd == 2 && up == nu && up == nu && nv && !nwd) data = up ? 3 : 4;
        }
        else if (b.getState("weirdo_direction") == 1) {
            if (up == nu && nwd == 1 && up == wu && wwd == 3) data = up ? 1 : 2;
            else if (up == su && swd == 1 && up == wu && wwd == 2) data = up ? 2 : 1;
            else if (up == nu && nwd == 1 && up == eu && ewd == 2) data = up ? 4 : 3;
            else if (up == su && swd == 1 && up == eu && ewd == 3) data = up ? 3 : 4;
        }
        else if (b.getState("weirdo_direction") == 2) {
            if (up == wu && wwd == 2 && up == su && swd == 1) data = up ? 1 : 2;
            else if (up == eu && up == eu && ewd == 2 && up == su && sv && !swd) data = up ? 2 : 1;
            else if (up == wu && wwd == 2 && up == nu && nv && !nwd) data = up ? 4 : 3;
            else if (up == eu && ewd == 2 && up == nu && nwd == 1) data = up ? 3 : 4;
        }
        else if (b.getState("weirdo_direction") == 3) {
            if (up == eu && ewd == 3 && up == nu && nv && !nwd) data = up ? 1 : 2;
            else if (up == wu && wwd == 3 && up == nu && nwd == 1) data = up ? 2 : 1;
            else if (up == eu && ewd == 3 && up == su && swd == 1) data = up ? 4 : 3;
            else if (up == wu && wwd == 3 && up == su && sv && !swd) data = up ? 3 : 4;
        }
        if (up) rot.x = 2;
        if (up) rot.y = (rot.y + 2) % 4;
        group = "6";
        resistance = getResistance("wooden_stairs");
    }

    else if (id === "cannon_block") {
        resistance = getResistance("cannon");
        solid = 0;
    }


    /**/
    return { typeId, skin, rot, resistance, group, data, solid };
}

function getBlockRotation(b, n) {
    let rot = new Vector(0, 0, 0);
    if (n == "facing_direction") {
        if (b.getState(n) == 0) rot.x = 1;
        else if (b.getState(n) == 1) rot.x = 3;
        else if (b.getState(n) == 2) rot.y = 2;
        else if (b.getState(n) == 4) rot.y = 1;
        else if (b.getState(n) == 5) rot.y = 3;
    } else if (n == "pillar_axis") {
        if (b.getState(n) == "x") rot.z = 1;
        else if (b.getState(n) == "z") rot.x = 1;
    } else if (n == "minecraft:cardinal_direction" || n == "torch_facing_direction") {
        if (b.getState(n) == "west") rot.y = 1;
        else if (b.getState(n) == "north") rot.y = 2;
        else if (b.getState(n) == "east") rot.y = 3;
    } else if (n == "minecraft:block_face") {
        if (b.getState(n) == "down") rot.x = 2;
        else if (b.getState(n) == "north") rot.x = 3;
        else if (b.getState(n) == "south") rot.x = 1;
        else if (b.getState(n) == "west") rot.z = 3;
        else if (b.getState(n) == "east") rot.z = 1;
    } else if (n == "direction") {
        rot.y = b.getState(n);
        if (b.getState(n) == 1) rot.y = 2;
        else if (b.getState(n) == 2) rot.y = 1;
    } else if (n == "weirdo_direction") {
        if (b.getState(n) == 0) rot.y = 1;
        else if (b.getState(n) == 1) rot.y = 3;
        else if (b.getState(n) == 2) rot.y = 2;
        else if (b.getState(n) == 3) rot.y = 0;
    }
    return rot;
}