import { system, Vector, world } from "../lib/Util";

world.beforeEvents.worldInitialize.subscribe(e => {
    e.blockComponentRegistry.registerCustomComponent('mship:furnace_engine', {
        onPlayerInteract: e => {
            if (e.block.getState("mship:fuel") >= 8) return;
            let item = e.player.getItem();
            if (item?.typeId.includes("coal")) {
                e.block.editState({ "mship:fuel": Math.min(e.block.getState("mship:fuel") + 1, 8) });
                if (e.player.getGameMode() === "creative") return;
                if (item.amount === 1) item = null;
                else item.amount -= 1;
                e.player.setItem(item);
            }
        },
        onTick: e => {
            if (e.block.typeId !== "mship:furnace_engine") return;
            if (e.block.getState("mship:fuel") == 0) return;
            let s0 = e.block.getState("mship:seconds_0") || 0;
            let s1 = e.block.getState("mship:seconds_1") || 0;
            let fuel = e.block.getState("mship:fuel") || 0;

            fuel = Math.max(fuel - (~~((s0 + 1) / 10) * ~~((s1 + 1) / 8)), 0);
            s1 = (s1 + ~~((s0 + 1) / 10)) % 8;
            s0 = (s0 + 1) % 10;

            e.block.editState({ "mship:seconds_0": s0, "mship:seconds_1": s1, "mship:fuel": fuel });

            let v = Vector.set(e.block.above().bottomCenter()).add(0, 0.25, 0);
            e.dimension.spawnParticle(e.block.above().hasTag("water") ? "mship:furnace_engine_bubble_particle" : "mship:furnace_engine_smoke_particle", v);
        }
    });
});

export default {};