import { world } from "../lib/Util";

world.beforeEvents.worldInitialize.subscribe(e => {
    e.blockComponentRegistry.registerCustomComponent('mship:seat', {
        onPlayerInteract: e => {
            let seat;
            e.block.dimension.getEntitiesAtBlockLocation(e.block).forEach(entity => {
                if (entity.hasFamily("seat")) seat = entity;
            });

            if (seat) seat.runCommandAsync("ride @s evict_riders");
            else {
                if (e.block.hasTag("cushion")) {
                    let seat = e.player.dimension.spawnEntity("mship:seat<mship:cushion>", e.block.bottomCenter());
                    seat.addTag("mship:isActive");
                    seat.addRider(e.player);
                }
                else if (e.block.hasTag("stool")) {
                    let seat = e.player.dimension.spawnEntity("mship:seat<mship:stool>", e.block.bottomCenter());
                    seat.addTag("mship:isActive");
                    seat.addRider(e.player);
                }
            }
        },
        onStepOn: e => {
            if (e.entity.typeId === "minecraft:player") return;
            let seat;
            e.block.dimension.getEntitiesAtBlockLocation(e.block).forEach(entity => {
                if (entity.hasFamily("seat")) seat = entity;
            });

            if (seat) return;
            if (e.block.hasTag("cushion")) {
                let seat = e.entity.dimension.spawnEntity("mship:seat<mship:cushion>", e.block.bottomCenter());
                seat.addTag("mship:isActive");
                seat.addRider(e.entity);
            }
            else if (e.block.hasTag("stool")) {
                let seat = e.entity.dimension.spawnEntity("mship:seat<mship:stool>", e.block.bottomCenter());
                seat.addTag("mship:isActive");
                seat.addRider(e.entity);
            }
        }
    });
});

export default {};