import { generateId, getEntity, system, world } from "../lib/Util";

world.beforeEvents.worldInitialize.subscribe(e => {
    e.itemComponentRegistry.registerCustomComponent('mship:cannon_remote', {
        onUse: e => {
            let code = e.itemStack.getDynamicProperty("mship:remoteId");
            if (code == undefined) return;
            e.source.dimension.getEntities({ tags: [`remoteId=${code}`] }).forEach(cannon => {
                if (!cannon.getComponent("minecraft:is_ignited")) {
                    if (cannon.isUnderWater) return e.source.onScreenDisplay.setActionBar(`Can't fire Underwater`);
                    if (e.source.getGameMode() === "survival") {
                        let list = e.source.findItem("mship:cannon_ball");
                        if (list.length > 0) {
                            e.source.setItem(list[0].item.setAmount(-1), list[0].slot);
                            cannon.triggerEvent("mship:fire");
                        } else e.source.onScreenDisplay.setActionBar(`No Ammo`);
                    } else cannon.triggerEvent("mship:fire");
                }
            });
        }
    });
});

world.beforeEvents.itemUseOn.subscribe(e => {
    if (e.itemStack.typeId !== "mship:cannon_remote") return;
    if (e.block.hasTag("cannon")) {
        e.cancel = true;
        let targetBlock = e.block;
        if (e.block.getState("mship:part") == 1) {
            let dir = e.block.getState("minecraft:cardinal_direction");
            if (dir === "north") targetBlock = e.block.north();
            else if (dir === "south") targetBlock = e.block.south();
            else if (dir === "east") targetBlock = e.block.east();
            else if (dir === "west") targetBlock = e.block.west();
        }
        system.run(_ => e.block.dimension.getEntitiesAtBlockLocation(targetBlock).some(entity => {
            if (entity.hasFamily("cannon")) {
                let code = e.itemStack.getDynamicProperty("mship:remoteId");
                if (!code) code = generateId(8);
                e.itemStack.setDynamicProperty("mship:remoteId", code);
                e.source.setItem(e.itemStack);
                entity.addDataAsTag("remoteId", code);
                return true;
            }
        }));
    }
});

export default {};