import { generateId, ModalFormData, system, world } from '../lib/Util';
import { VERSION } from '../index';
import { scan } from '../scan';

export function setupMenu(player, block) {
    if (block.getState("mship:used")) return;
    block.editState({ "mship:used": 1 });
    new ModalFormData().title("Setup")
        .textField("Name", "Input name", `${player.nameTag}'s Ship`)
        .slider(`\u00A7c\u00A7o* Higher Values may cause lag *\u00A7r\nMaximum Blocks`, world.getDynamicProperty("mship:min_blocks"), world.getDynamicProperty("mship:max_blocks"), 1, 1024)
        .show(player).then(res => {
            if (res.cancelationReason == "UserBusy") return;
            const data = {};
            data.version = VERSION;
            data.id = `mship:ship${generateId(4, ["SPECIAL"])}`;
            data.shipId = "";
            data.name = `${res.formValues[0] || `${player.nameTag}' Ship`}`;
            data.min = 12;
            data.max = res.formValues[1];
            data.cameraDistance = 5;
            data.facing = block.permutation.getState('minecraft:cardinal_direction');
            data.angle = { 'west': -90, 'north': 0, 'east': 90, 'south': -180 }[data.facing];
            data.location = block.location;
            data.owner = player.id;
            data.camera = false;
            data.locked = false;
            data.state = "default";
            data.y = 0;
            data.lowestY = 0;
            data.blocks = {};
            data.cache = [];
            data.entities = [];
            data.dblocks = [];
            data.spawnPoints = {};
            data.alerts = [];
            data.minPos = block.v3();
            data.maxPos = block.v3();
            data.centerY = 0;
            data.centerYaw = 0;
            data.centerDist = 0;
            data.dimension = { width: 0, height: 0, length: 0 };
            data.hashMap = {};
            data.valid = world.getDynamicProperty("mship:valid_blocks");
            world.setProperty(data.id, JSON.stringify(data));
            system.run(_ => scan(player, block, data));
        }).catch(_ => { block.editState({ "mship:used": 0 }); });
}

export default { setupMenu }